program importcol;
{$APPTYPE CONSOLE}
uses SysUtils, Windows;

const OFFSET=2874;

type TPixel=packed record R,G,B:byte; end;
     TColorEntry=packed record
                   Name:string[45];
                   Look,Active:char;
                   Color:TPixel;
                 end;

const Hex:array[0..15]of char='0123456789ABCDEF';

var f:file; sz:integer;
    ct:packed array of TColorEntry;
    OEM,ANSI:array[0..45]of char;
    OEM2,ANSI2:array[0..1]of char;
    C:integer;
begin
  AssignFile(f,'PAPERPIC.CFG');
  {$I-} Reset(f,1); {$I+}
  if IOresult<>0 then begin
    writeln('PAPERPIC.CFG existiert nicht!');
    halt;
  end;

  {$I-} Seek(f,OFFSET); {$I-}
  if IOresult<>0 then begin
    writeln('Ungltiges Format!');
    CloseFile(f); halt;
  end;

  sz:=FileSize(f)-OFFSET;
  if (sz MOD sizeof(TColorEntry))<>0 then begin
    writeln('Ungltiges Format!');
    CloseFile(f); halt;
  end;
  sz:=sz DIV sizeof(TColorEntry);
  SetLength(ct,sz);
  BlockRead(f,ct[0],sz*sizeof(TColorEntry));

  OEM2[1]:=#0;
  for C:=0 to (sz-1) do with ct[C] do if Name<>'-' then begin
    Move(Name[1],OEM[0],length(Name)); OEM[length(Name)]:=#0;
    OemToChar(OEM,ANSI);
    if Look<#32 then Look:=#32;
    OEM2[0]:=Look; OemToChar(OEM2,ANSI2);
    if Active=#254 then Active:='+' else Active:='-';
    writeln(Active,
            Hex[Color.R SHR 4],Hex[Color.R AND 15],
            Hex[Color.G SHR 4],Hex[Color.G AND 15],
            Hex[Color.B SHR 4],Hex[Color.B AND 15],
            '00',ANSI2,ANSI);
  end;

  CloseFile(f);
end.
